; Cwiczenie nr na laboratoria z Asemblerow
; (C) 2000 Marcin Owsiany

; Program przyjmuje nastepujace opcje:
;   u - zamiana malych liter na duze
;   l - zamiana duzych liter na male
;   N - wycina cyfry
;   L - wycina litery
; Opcje mozna ze soba laczyc


assume CS:main, DS:dane

stosik segment stack
	db 512 dup (?)
stosik ends

dane segment
	prosba	db "Wpisz tekst: $"		; rozne
	info1	db "Trwa przetwarzanie...$"	; teksty
	info2	db "gotowe.$"			; informacyjne
	wynik	db "Przetworzony tekst: $"
	badopts db "Nieprawidlowa opcja.", 13, 10
		db "Wpisz sama nazwe programu, aby uzyskac pomoc.$"
	helptxt db "Uzycie programu: m [opcje]", 13, 10
		db "Gdzie opcje to ciag jednej lub wiecej liter:", 13, 10
		db "      N    -    pomijanie liter", 13, 10
		db "      L    -    pomijanie cyfr", 13, 10
		db "      u    -    zamiana malych liter na duze", 13, 10
		db "      l    -    zamiana duzych liter na male$"
	endl	db '', 13, 10, '$'		; CL+LF
	znaki	db 300 dup (?)			; bufor na znaki
	len	db ?
dane ends

main segment

; wypisuje string wskazywany przez dx
write proc
	mov  ah, 9
	int  21h
	ret
write endp

; wypisuje string wskazywany przez bx o dlugosci w cx
mywrite proc
	mov ah, 2
	xor si, si
mwl:		mov  dl, ds:[bx+si]
		int  21h
		inc  si
		loop mwl
	ret
mywrite endp

; zle opcje
opterr proc
	lea  dx, endl
	call write
	lea  dx, badopts
	call write
	lea  dx, endl
	call write
	mov  ah, 4ch
	mov  al, 1
	int  21h
opterr endp

; pomoc
helpmsg proc
	lea  dx, endl
	call write
	lea  dx, helptxt
	call write
	lea  dx, endl
	call write
	mov  ah, 4ch
	mov  al, 1
	int  21h
helpmsg endp

; zamienia male litery na duze
upcase proc
	mov  cx, si
	mov  dx, cx	; na pozniej
	sub  si, 1
uznak:		mov  al, byte ptr ds:[znaki+si]
		cmp  al, 'a'			; jesli mniej niz a
		jl   udalej
		cmp  al, 'z'			; lub wiecej niz z
		jg   udalej			; to nie zmieniaj
		sub  al, 32			; zmien i
		mov  byte ptr ds:[znaki+si], al	; zapisz do bufora
udalej:	dec  si
	loop uznak
	mov  si, dx	; sprzed petli
	ret
upcase endp

; zamienia duze litery na male
; dzialanie analogiczne do upcase, ze zmienionym zakresem znakow
lowcase proc
	mov  cx, si
	mov  dx, cx	; na pozniej
	sub  si, 1
lznak:		mov  al, byte ptr ds:[znaki+si]
		cmp  al, 'A'
		jl   ldalej
		cmp  al, 'Z'
		jg   ldalej
		add  al, 32
		mov  byte ptr ds:[znaki+si], al
ldalej:	dec  si
	loop lznak
	mov  si, dx	; sprzed petli
	ret
lowcase endp

; opuszcza cyfry
numstrip proc
	mov  cx, si
	xor  si, si
	xor  di, di
nznak:		mov  al, byte ptr ds:[znaki+si]
		cmp  al, '0'			; jesli mniej niz 0
		jl   nok			; lub
		cmp  al, '9'			; wiecej niz 9
		jg   nok			; to ->
		inc  si				; w przeciwnym wypadku tylko
		jmp  ndalej			; zwieksz indeks zrodla
nok:		mov  byte ptr ds:[znaki+di], al	; -> przepisz
		inc  si				; zwieksz
		inc  di				; oba indeksy
ndalej:	loop nznak
	mov  al, '$'				; dopisz znak konca stringu
	mov  byte ptr ds:[znaki+di], al
	mov  si, di				; nowa dlugosc wraca do si
	ret
numstrip endp

; opuszcza litery
chrstrip proc
	mov  cx, si
	xor  si, si
	xor  di, di
cznak:		mov  al, byte ptr ds:[znaki+si]	; jesli znak
		cmp  al, 'A'			; mniejszy niz A
		jl   cok			; lub
		cmp  al, 'z'			; wiekszy niz z
		jg   cok			; to nie pomijaj (cok)
		cmp  al, 91			; jesli miedzy 'Z'
		jl   cstrip			; lub
		cmp  al, 96			; 'a', to
		jg   cstrip			; pomijaj
		jmp  cok
cstrip:		inc  si				; zwieksz tylko indeks zrodla
		jmp  cdalej
cok:		mov  byte ptr ds:[znaki+di], al	; przepisz
		inc  si				; zwieksz
		inc  di				; oba indeksy
cdalej:	loop cznak
	mov  al, '$'				; dopisz znak konca stringu
	mov  byte ptr ds:[znaki+di], al
	mov  si, di				; nowa dlugosc wraca do si
	ret
chrstrip endp

start:
; ustawienie segmentu danych
	mov  ax, dane
	mov  ds, ax
; sprawdz, czy sa w ogole jakies opcje
	xor  cx, cx
	mov  cl, es:[80h]
	cmp  cx, 0		; jesli brak opcji...
	jne  optsex
	call helpmsg		; ...to zglos blad
; wypisanie prosby
optsex:	lea  dx, prosba
	call write
; odczyt
	mov  ah, 1
	xor  si, si
	mov  cx, 298
znak:		int  21h		; pobranie znaku
		mov  ds:[znaki+si], al	; zapisanie do tablicy
		inc  si			; zwiekszenie indeksu tablicy
		cmp  al, 13		; jesli byl to CR
		je   last		; to koniec
		loop znak		; jesli bufor niepelny -> nastepny znak
last:	mov  byte ptr ds:znaki+si, 10	; dopisanie LF
	inc  si				; i
	mov  byte ptr ds:znaki+si, '$'	; konca stringu
	lea  dx, endl
	call write
; informacja 1 (rozpoczecie przetwarzania)
	lea  dx, info1
	call write
; przetwarzanie
; sprawdzenie opcji
	xor  cx, cx
	mov  cl, es:80h
	dec  cl			; pomijamy spacje na poczatku argumentow
pcont:	xor  di, di		; uzywany jako offset w linii polecen
parse:		mov  al, es:[82h + di]	; pobierz znak
		cmp  al, 'u'		; jesli jest to opcja
		jne  przc1		; to
		push cx			; rejestr -> stos
		call upcase		; dana procedura
		pop  cx			; rejestr wraca
		jmp  przc4		; nastepny znak
przc1:		cmp  al, 'l'
		jne  przc2
		push cx
		call lowcase
		pop  cx
		jmp  przc4
przc2:		cmp  al, 'N'
		jne  przc3
		push cx
		push di			; w procedurach wycinania
		call numstrip			; odkladamy na stos
		pop  di				; takze rejestr di
		pop  cx
		jmp  przc4
przc3:		cmp  al, 'L'
			je   noopterr
			call opterr
noopterr:	push cx
		push di
		call chrstrip
		pop  di
		pop  cx
przc4:		inc  di
	loop parse
; informacja 2 (zakonczenie przetwarzania)
	lea  dx, info2
	call write
	lea  dx, endl
	call write
; przetworzony tekst:
	lea  dx, wynik
	call write
; wypisanie danych
	sub  si, 1			; bez '$' na koncu
	lea  bx, znaki			; offset stringu wynikowego
	mov  cx, si			; dlugosc stringu
	call mywrite
; koniec
exit:	mov  ah, 4ch
	mov  al, 0
	int  21h
main ends
end start
